 function varargout = FEMTO(varargin)
% FEMTO MATLAB code for FEMTO.fig
%      FEMTO, by itself, creates a new FEMTO or raises the existing
%      singleton*.
%
%      H = FEMTO returns the handle to a new FEMTO or the handle to
%      the existing singleton*.
%
%      FEMTO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FEMTO.M with the given input arguments.
%
%      FEMTO('Property','Value',...) creates a new FEMTO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FEMTO_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FEMTO_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FEMTO

% Last Modified by GUIDE v2.5 09-Nov-2016 11:07:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FEMTO_OpeningFcn, ...
                   'gui_OutputFcn',  @FEMTO_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
 
% End initialization code - DO NOT EDIT


% --- Executes just before FEMTO is made visible.
function FEMTO_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FEMTO (see VARARGIN)

% Choose default command line output for FEMTO
handles.output = hObject;

warning('off','all')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FEMTO wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FEMTO_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.Data Import
%Rows are variables, columns are replicates/time points
%First column: Names of variables, First row: replicates
function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.pushbutton1,'BackgroundColor','cyan')
[Filename, Filepath]=uigetfile(...
    {'*.*'}); 
variables = uiimport(fullfile(Filepath,Filename),-1);
handles.variables = variables;

assignin('base','data_import',handles.variables);
% 
%pre-define if absolute values are available - default:0
%can be changed later in checkbox2!
check_abs = 0;
assignin('base','check_abs',check_abs);
%
%pre-define threshold for cut-off of ratio selection - default:0
%can be changed later in textbox_edit8!
handles.k = 0;
assignin('base','Threshold',handles.k);
%
%
guidata(hObject, handles);
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in pushbutton4. Time points and Replicates
function pushbutton4_Callback(hObject, eventdata, handles)
set(handles.pushbutton4,'BackgroundColor','cyan')
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

prompt = {'Time Points: [TP1 TP2 ...]',...
            'No. of Replicates:'};
        name = 'TP and Replicates';
        numlines = [1 50;1 50];
  
tp_rep=inputdlg(prompt,name,numlines);

if length(tp_rep) > 0
    TP_2=num2str(tp_rep{1});
    Rep=num2str(tp_rep{2});
    for k = 1:str2num(Rep)
        tp_mat(k,:) = str2num(TP_2);
    end
    handles.timepoints = tp_mat(1,:);
    assignin('base','timepoints',tp_mat);
    assignin('base','replicates',str2num(Rep));
end

    %Re-organize data structure so that replicates of each metabolite are
    %summarized in columns for each time point. Each metabolite is
    %summarized in a single matrix within the data structure of
    %'Data_Import'
call_data_import = evalin('base','data_import');

%Create new Structure for data organization
data_summary = struct();
data_reorg = struct();
handles.regression_analysis = struct();

size_of_labels = size(call_data_import.textdata);
number_of_variables = size_of_labels(1,1) - 1; %due to the first header line which is not a variable
number_of_time_points = size(tp_mat);
number_of_TP = number_of_time_points(1,2);

%write experimental data in structure
for k = 1:number_of_variables
    handles.name_all{k}=call_data_import.textdata{k+1};
    name = call_data_import.textdata{k+1}; % first line is header of columns
    data_summary.(name) = struct(call_data_import.textdata{k+1},call_data_import.data(k,:));


        %re-organize data 
        for m = 1:number_of_TP
            for n = 1:str2num(Rep)
                data_reorg.(name).data(n,m) = data_summary.(name).(name)(1,((m*str2num(Rep))-(str2num(Rep)-n)));
            end
        end
    
    %calculate Variance/weights and write in structure
    data_reorg.(name).variance = nanvar(data_reorg.(name).data);
    
        for n = 1:str2num(Rep)
            data_reorg.(name).weight(n,:) = 1./(data_reorg.(name).variance(1,:));
        end
    
end
    
%write data to workspace - can be saved at any time!
assignin('base','data_summary',data_summary)
assignin('base','data_reorg',data_reorg)
assignin('base','variable_names',handles.name_all)


set(handles.listbox9,'String',handles.name_all)

guidata(hObject,handles)


% --- Executes on selection change in listbox9. Select a variable for
% fitting
function listbox9_Callback(hObject, eventdata, handles)



% Select a variable from Listbox for Regression analysis
items = get(hObject,'String');
index_selected = get(hObject,'Value');
handles.item_selected = items{index_selected};
handles.call_selected_variable = evalin('base','data_reorg');
data_selected = handles.call_selected_variable.(handles.item_selected).data;
weight_selected = handles.call_selected_variable.(handles.item_selected).weight;
assignin('base',handles.item_selected,data_selected)
assignin('base','Selected_Weights',weight_selected)
call_TP = evalin('base','timepoints');

%Save item_selected to be used in Regression analysis/cftool
guidata(hObject,handles)



% hObject    handle to listbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox9 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox9


% --- Executes during object creation, after setting all properties.
function listbox9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over listbox9.
function listbox9_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to listbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --- Executes on button press in pushbutton2. cftool
function pushbutton2_Callback(hObject, eventdata, handles)
set(handles.pushbutton2,'BackgroundColor','cyan')
cftool
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton15. Save current regression
% analysis to structure of the variable
function pushbutton15_Callback(hObject, eventdata, handles)
set(handles.pushbutton15,'BackgroundColor','cyan')

%make regression results available for gui
fittedmodel = evalin('base','fittedmodel');
goodness = evalin('base','goodness');
output = evalin('base','output');

%write results in structure
handles.regression_analysis.(handles.item_selected).fittedmodel = '';
handles.regression_analysis.(handles.item_selected).goodness = '';
handles.regression_analysis.(handles.item_selected).output = '';
handles.regression_analysis.(handles.item_selected).fittedmodel =fittedmodel;
handles.regression_analysis.(handles.item_selected).goodness = goodness;
handles.regression_analysis.(handles.item_selected).output = output;

%write result structure into workspace
assignin('base','regression_analysis',handles.regression_analysis);
%
handles.str4listbox = fieldnames(handles.regression_analysis);
%
%clear the reuslts from workspace, but not the result structure!
evalin('base','clearvars -except data* regression* variable* replicates* timepoints* str4call* check_abs Threshold');

set(handles.listbox14,'String',handles.str4listbox)



%interpolation of time points to get high resolution of differentiation
%100x time point distance

handles.time4diff = linspace (handles.timepoints(1,1),handles.timepoints(1,length(handles.timepoints(1,:))),(handles.timepoints(1,length(handles.timepoints(1,:))))*100);

    
%1st and 2nd derivative of all analysed variables
%
%read fieldnames in regression_analysis
handles.fieldnames_regression = fieldnames(handles.regression_analysis);
handles.number_of_fields = length(handles.fieldnames_regression);

%evaluate the time courses
for i = 1:(handles.number_of_fields)
    handles.eval_fit.(handles.fieldnames_regression{i}).eval = feval(handles.regression_analysis.(handles.fieldnames_regression{i}).fittedmodel,handles.time4diff);
    [handles.eval_fit.(handles.fieldnames_regression{i}).diff1,handles.eval_fit.(handles.fieldnames_regression{i}).diff2] = differentiate(handles.regression_analysis.(handles.fieldnames_regression{i}).fittedmodel,handles.time4diff);
    handles.eval_fit.(handles.fieldnames_regression{i}).norm2max_diff1 = handles.eval_fit.(handles.fieldnames_regression{i}).diff1./(max(abs(handles.eval_fit.(handles.fieldnames_regression{i}).diff1)));
    handles.eval_fit.(handles.fieldnames_regression{i}).norm2max_diff2 = handles.eval_fit.(handles.fieldnames_regression{i}).diff2./(max(abs(handles.eval_fit.(handles.fieldnames_regression{i}).diff2)));
    handles.eval_fit.(handles.fieldnames_regression{i}).diff1_relative = 1-(abs(handles.eval_fit.(handles.fieldnames_regression{i}).norm2max_diff1));
    handles.eval_fit.(handles.fieldnames_regression{i}).diff2_relative = 1-(abs(handles.eval_fit.(handles.fieldnames_regression{i}).norm2max_diff2));    
end
%
assignin('base','fcn_evaluation',handles.eval_fit);

guidata(hObject,handles);
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over pushbutton15.
function pushbutton15_ButtonDownFcn(hObject, eventdata, handles)

% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on selection change in listbox14. Fitted and saved items
function listbox14_Callback(hObject, eventdata, handles)

% hObject    handle to listbox14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox14 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox14


% --- Executes during object creation, after setting all properties.
function listbox14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over listbox14.
function listbox14_ButtonDownFcn(hObject, eventdata, handles)

% hObject    handle to listbox14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)






% --- Executes on button press in pushbutton16. Load stoichiometric matrix
function pushbutton16_Callback(hObject, eventdata, handles)
set(handles.pushbutton16,'BackgroundColor','cyan')
[Filename, Filepath]=uigetfile(...
    {'*.*'});
N = uiimport(fullfile(Filepath,Filename),-1);
handles.N = N.data;
handles.variables_textdata = N.textdata;
handles.number_variables_textdata = length(handles.variables_textdata(:,1));
handles.variables_N = N.textdata(2:handles.number_variables_textdata,1);
handles.number_variables_N = length(handles.variables_N);
%
assignin('base','N',handles.N);
assignin('base','Variables_in_N',handles.variables_N);
%
%define unity matrix with length of variables
handles.I_matrix = eye(handles.number_variables_N);
%
%
%define non-diagonal entries in I from N
for i = 1:length(handles.N)
    for k = 1:handles.number_variables_N
        if handles.N(k,i) < 0
            [row,col] = find (handles.N(:,i)>0);
            handles.I_matrix(row,k) = 1;
        end
    end
end


%unify listbox11/12 (version1.0) and load of N in one step
%
%define cells for interactions
handles.interactions_df=cell(1);
handles.interactions_dM=cell(1);
%
for k = 1:handles.number_variables_N
    for i = 1:handles.number_variables_N
        if handles.I_matrix(k,i) == 1
            index_df = length(handles.interactions_df);
            index_dM = length(handles.interactions_dM);
            handles.interactions_df(index_df+1,1) = handles.variables_N(k,1);
            handles.interactions_dM(index_dM+1,1) = handles.variables_N(i,1);
        end
    end
end
%
%delete first empty row
handles.interactions_df(1,:)=[];
handles.interactions_dM(1,:)=[];
%
%define cell with unique entries for df
handles.unique_interactions_df = unique(handles.interactions_df,'stable');
%
handles.interactions = [handles.interactions_df,handles.interactions_dM];    





assignin('base','Interactions',handles.interactions) 

assignin('base','IntMatrix',handles.I_matrix)


for i = 1:length(handles.interactions)
    handles.list_of_interactions{i} = sprintf('%s -> %s',handles.interactions{i,1},handles.interactions{i,2});
end
set(handles.listbox15,'String',handles.list_of_interactions)


guidata(hObject,handles);

% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)






% --- Executes on selection change in listbox15. All interactions described in the interaction matrix are
% listed in this box
function listbox15_Callback(hObject, eventdata, handles)
% hObject    handle to listbox15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)






index = get(handles.listbox15,'value'); %get index of selection

cla reset % reset axes object

try
    eval(['num = handles.eval_fit.' handles.interactions{index, 1} '.diff2;' ]); %2nd derivative of left side metabolite
    eval(['denom = handles.eval_fit.' handles.interactions{index, 2} '.diff1;' ]); %1st derivative of right side metabolite
    handles.interactionplot = num./denom;
    axes(handles.axes12)
    stem((transpose(handles.time4diff)),handles.interactionplot,'LineWidth',1,'Marker','none');
    assignin('base', 'interactionplot', handles.interactionplot)
    
catch
    
    cla reset  % reset axes object
    handles.interactionplot = 1;
    plot(1,1)
    hold on
    legend('At least one variable not available','location','northeast')
   
end



guidata(hObject, handles);


% Hints: contents = cellstr(get(hObject,'String')) returns listbox15 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox15


% --- Executes during object creation, after setting all properties.
function listbox15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



guidata(hObject,handles);




% --- Executes on button press in pushbutton9. Save selection to file.
function pushbutton9_Callback(hObject, eventdata, handles)
%

for i = 1:length(handles.interactions)
    try
        eval(['num = handles.eval_fit.' handles.interactions{i, 1} '.diff2;' ]); %2nd derivative of left side metabolite
        eval(['denom = handles.eval_fit.' handles.interactions{i, 2} '.diff1;' ]); %1st derivative of right side metabolite
        eval(['Calculated_Interactions(:,i) = num./denom;']);
        eval(['Listed_Interactions{i} = handles.list_of_interactions{i};']);
    catch
        eval(['Calculated_Interactions(:,i) = [nan];']);
        eval(['Listed_Interactions{i} = handles.list_of_interactions{i};']);
    end
end

assignin ('base','Calculated_Interactions',Calculated_Interactions)
assignin ('base', 'Labels_Interactions', handles.list_of_interactions)


[file_name_table,file_path_table] = uiputfile (...
         {'*.mat'},...
         'Save as');
outname_table = fullfile(file_path_table, file_name_table);

evalin('base', ['save(''', outname_table ''')']);

choice1 = questdlg('The Table was saved within a workspace. All data are provided in the matrix >>Calculated_Interactions<<. Headers are provided in >>Labels_Interactions<<. Would you also like to save it to another file-format (*.xlsx or *.csv)?');
 switch choice1;
     case 'Yes';
         
         choice2 = questdlg('Please indicate the favoured file format: ','File format','xlsx','csv','Cancel','Cancel');
             switch choice2
                 
                 case 'xlsx'
                     [file_name_table_xlsx,file_path_table_xlsx] = uiputfile (...
                         {'*.xlsx'},...
                             'Save as');
                      outname_table_xlsx = fullfile(file_path_table_xlsx, file_name_table_xlsx);   
                         xlswrite(outname_table_xlsx, Calculated_Interactions,'Sheet1','A2');
                         xlswrite(outname_table_xlsx, handles.list_of_interactions,'Sheet1','A1');
                     
                 case 'csv'
                     [file_name_table_csv,file_path_table_csv] = uiputfile (...
                         {'*.csv'},...
                             'Save as');
                      outname_table_csv = fullfile(file_path_table_csv, file_name_table_csv);   
                         csvwrite(outname_table_csv, Calculated_Interactions)
               
                
             end
end

guidata(hObject,handles);
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
[file_name_all,file_path_all] = uiputfile(...
    {'*.mat'},...
    'Save as');
outname_all = fullfile(file_path_all, file_name_all);
evalin('base', ['save(''', outname_all ''')']);
guidata(hObject,handles);
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
winopen('FEMTO2_Manual.pdf');
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton14. Quit GUI
function pushbutton14_Callback(hObject, eventdata, handles)
% Construct a questdlg with two options
choice = questdlg('Do you really want to quit ?','Quit');
switch choice;
    case 'Yes';
       close(gcf);
end


% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over pushbutton14.
function pushbutton14_ButtonDownFcn(hObject, eventdata, handles)

% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton18. Button to restart GUI
function pushbutton18_Callback(hObject, eventdata, handles)
choice = questdlg('Do you really want to restart? All Data in the current workspace will be deleted!','Restart');
switch choice;
    case 'Yes';
       evalin('base','clearvars *');
        close(gcbf);
        FEMTO
end



% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over pushbutton18.
function pushbutton18_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axes12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes12


% --- Executes on button press in pushbutton19. Export current axes figure.
function pushbutton19_Callback(hObject, eventdata, handles)
index = get(handles.listbox15,'value');
figure
try
stem((transpose(handles.time4diff)),handles.interactionplot,'LineWidth',1,'Marker','none');
hold on
legend (handles.list_of_interactions{index})
xlabel('Time')
ylabel('Omega(t)')
catch
end
% hObject    handle to pushbutton19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when figure1 is resized.
function figure1_SizeChangedFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
